Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/iWork.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/iWork.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/iWork.pm	(revision 34921)
@@ -15,20 +15,20 @@
 use Image::ExifTool::ZIP;
 
-$VERSION = '1.02';
-
-# test for recognized iWork document extensions and outter XML elements
+$VERSION = '1.06';
+
+# test for recognized iWork document extensions and outer XML elements
 my %iWorkType = (
     # file extensions
-    NUMBERS => 'Apple Numbers',
-    PAGES   => 'Apple Pages',
-    KEY     => 'Apple Keynote',
-    KTH     => 'Apple Keynote Theme',
-    NMBTEMPLATE => 'Apple Numbers Template',
+    NUMBERS => 'NUMBERS',
+    PAGES   => 'PAGES',
+    KEY     => 'KEY',
+    KTH     => 'KTH',
+    NMBTEMPLATE => 'NMBTEMPLATE',
     # we don't support double extensions --
     # "PAGES.TEMPLATE" => 'Apple Pages Template',
-    # outter XML elements
-    'ls:document' => 'Apple Numbers',
-    'sl:document' => 'Apple Pages',
-    'key:presentation' => 'Apple Keynote',
+    # outer XML elements
+    'ls:document' => 'NUMBERS',
+    'sl:document' => 'PAGES',
+    'key:presentation' => 'KEY',
 );
 
@@ -37,10 +37,10 @@
 # indicates, but I think it refers to the new "flattened" package format)
 my %mimeType = (
-    'Apple Numbers' => 'application/x-iwork-numbers-sffnumbers',
-    'Apple Pages'   => 'application/x-iwork-pages-sffpages',
-    'Apple Keynote' => 'application/x-iWork-keynote-sffkey',
-    'Apple Numbers Template' => 'application/x-iwork-numbers-sfftemplate',
-    'Apple Pages Template'   => 'application/x-iwork-pages-sfftemplate',
-    'Apple Keynote Theme'    => 'application/x-iWork-keynote-sffkth',
+    'NUMBERS'       => 'application/x-iwork-numbers-sffnumbers',
+    'PAGES'         => 'application/x-iwork-pages-sffpages',
+    'KEY'           => 'application/x-iWork-keynote-sffkey',
+    'NMBTEMPLATE'   => 'application/x-iwork-numbers-sfftemplate',
+    'PAGES.TEMPLATE'=> 'application/x-iwork-pages-sfftemplate',
+    'KTH'           => 'application/x-iWork-keynote-sffkth',
 );
 
@@ -71,5 +71,5 @@
     my $props = shift;
     return 0 if $$props[-1] =~ /^\w+:ID$/;  # ignore ID tags
-    return ($$props[0] =~ /.*?:(.*)/) ? $1 : $$props[0];
+    return $$props[0] =~ /^.*?:(.*)/ ? $1 : $$props[0];
 }
 
@@ -82,23 +82,23 @@
 sub FoundTag($$$$;$)
 {
-    my ($exifTool, $tagTablePtr, $props, $val, $attrs) = @_;
+    my ($et, $tagTablePtr, $props, $val, $attrs) = @_;
     return 0 unless @$props;
-    my $verbose = $exifTool->Options('Verbose');
-
-    $exifTool->VPrint(0, "  | - Tag '", join('/',@$props), "'\n") if $verbose > 1;
+    my $verbose = $et->Options('Verbose');
+
+    $et->VPrint(0, "  | - Tag '", join('/',@$props), "'\n") if $verbose > 1;
 
     # un-escape XML character entities
     $val = Image::ExifTool::XMP::UnescapeXML($val);
     # convert from UTF8 to ExifTool Charset
-    $val = $exifTool->Decode($val, 'UTF8');
+    $val = $et->Decode($val, 'UTF8');
     my $tag = GetTagID($props) or return 0;
 
     # add any unknown tags to table
     unless ($$tagTablePtr{$tag}) {
-        $exifTool->VPrint(0, "  [adding $tag]\n") if $verbose;
-        Image::ExifTool::AddTagToTable($tagTablePtr, $tag, { Name => ucfirst $tag });
+        $et->VPrint(0, "  [adding $tag]\n") if $verbose;
+        AddTagToTable($tagTablePtr, $tag, { Name => ucfirst $tag });
     }
     # save the tag
-    $exifTool->HandleTag($tagTablePtr, $tag, $val);
+    $et->HandleTag($tagTablePtr, $tag, $val);
 
     return 1;
@@ -113,5 +113,5 @@
 sub Process_iWork($$)
 {
-    my ($exifTool, $dirInfo) = @_;
+    my ($et, $dirInfo) = @_;
     my $zip = $$dirInfo{ZIP};
     my ($type, $index, $indexFile, $status);
@@ -120,5 +120,5 @@
     local $SIG{'__WARN__'} = \&Image::ExifTool::ZIP::WarnProc;
     # trust type given by file extension if available
-    $type = $iWorkType{$$exifTool{FILE_EXT}} if $$exifTool{FILE_EXT};
+    $type = $iWorkType{$$et{FILE_EXT}} if $$et{FILE_EXT};
     unless ($type) {
         # read the index file
@@ -132,8 +132,14 @@
                 }
             }
+        } else {
+            @members = $zip->membersMatching('(?i)^.*\.(pages|numbers|key)/Index.*');
+            if (@members) {
+                my $tmp = $members[0]->fileName();
+                $type = $iWorkType{uc $1} if $tmp =~ /\.(pages|numbers|key)/i;
+            }
         }
         $type or $type = 'ZIP';     # assume ZIP by default
     }
-    $exifTool->SetFileType($type, $mimeType{$type});
+    $et->SetFileType($type, $mimeType{$type});
 
     my @members = $zip->members();
@@ -144,11 +150,11 @@
         my $file = $member->fileName();
         next unless defined $file;
-        $exifTool->VPrint(0, "File: $file\n");
+        $et->VPrint(0, "File: $file\n");
         # set the document number and extract ZIP tags
-        $$exifTool{DOC_NUM} = ++$docNum;
-        Image::ExifTool::ZIP::HandleMember($exifTool, $member);
-
-        # process only the index XML and JPEG thumbnail files
-        next unless $file =~ m{^(index\.(xml|apxl)|QuickLook/Thumbnail\.jpg)$}i;
+        $$et{DOC_NUM} = ++$docNum;
+        Image::ExifTool::ZIP::HandleMember($et, $member);
+
+        # process only the index XML and JPEG thumbnail/preview files
+        next unless $file =~ m{^(index\.(xml|apxl)|QuickLook/Thumbnail\.jpg|[^/]+/preview(-micro|-web)?.jpg)$}i;
         # get the file contents if necessary
         # (CAREFUL! $buff MUST be local since we hand off a value ref to PreviewImage)
@@ -159,10 +165,11 @@
         } else {
             ($buff, $status) = $zip->contents($member);
-            $status and $exifTool->Warn("Error extracting $file"), next;
+            $status and $et->Warn("Error extracting $file"), next;
             $buffPt = \$buff;
         }
         # extract JPEG as PreviewImage (should only be QuickLook/Thumbnail.jpg)
         if ($file =~ /\.jpg$/) {
-            $exifTool->FoundTag('PreviewImage', $buffPt);
+            my $type = ($file =~ /preview-(\w+)/) ? ($1 eq 'web' ? 'Other' : 'Thumbnail') : 'Preview';
+            $et->FoundTag($type . 'Image', $buffPt);
             next;
         }
@@ -183,8 +190,8 @@
         );
         my $tagTablePtr = GetTagTable('Image::ExifTool::iWork::Main');
-        $exifTool->ProcessDirectory(\%dirInfo, $tagTablePtr);
+        $et->ProcessDirectory(\%dirInfo, $tagTablePtr);
         undef $$buffPt; # (free memory now)
     }
-    delete $$exifTool{DOC_NUM};
+    delete $$et{DOC_NUM};
     return 1;
 }
@@ -209,5 +216,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
Index: /main/trunk/greenstone2/perllib/plugins/EmbeddedMetadataPlugin.pm
===================================================================
--- /main/trunk/greenstone2/perllib/plugins/EmbeddedMetadataPlugin.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/plugins/EmbeddedMetadataPlugin.pm	(revision 34921)
@@ -72,4 +72,10 @@
 	'deft' => " "
 	},{
+	'name' => "apply_join_before_split_to_metafields",
+	'desc' => "{EmbeddedMetadataPlugin.apply_join_before_split_to_metafields}",
+	'type' => "string",
+	'reqd' => "no",
+	'deft' => ".*Keywords" # regex. Set to .* to apply join_before_split to All meta fields (that are arrays of values)
+	},{
 	'name' => "trim_whitespace",
 	'desc' => "{EmbeddedMetadataPlugin.trim_whitespace}",
@@ -309,4 +315,10 @@
     }
 
+    # Check if join_before_split is only applied to spefified fields or all fields
+    my $apply_join_before_split_to_metafields = $self->{'apply_join_before_split_to_metafields'};
+    if($apply_join_before_split_to_metafields eq "") {
+	undef $apply_join_before_split_to_metafields;	
+    }
+    
     my @group_list = Image::ExifTool::GetAllGroups(0);
     foreach my $group (@group_list) {
@@ -350,4 +362,12 @@
 				}
 				elsif (ref $value eq 'ARRAY') {
+				    my $join_before_split_for_this_field = $self->{'join_before_split'}; # if join_before_split set, will apply it to all metadata fields 
+				    # If specific metadata fields specified, only apply join_before_split to those fields
+				    # (in which case check if current metadata field matches any of those metadata fields)
+				    # else apply to all metadata fields as before
+				    if($join_before_split_for_this_field && $apply_join_before_split_to_metafields && $field !~ m/$apply_join_before_split_to_metafields/) {					    
+					undef $join_before_split_for_this_field;					
+				    }
+				    
 					$metadata_done = 1;
 					
@@ -356,5 +376,5 @@
 						$v = Encode::decode($encoding,$v);
 						
-						if(!$self->{'join_before_split'}){
+						if(!$join_before_split_for_this_field) { # if(!$self->{'join_before_split'}){
 							if (defined $separator) {
 								my @vs = split($separator, $v);
@@ -377,6 +397,6 @@
 						}
 					}
-					
-					if($self->{'join_before_split'}){
+				    
+					if($join_before_split_for_this_field) { #if($self->{'join_before_split'}){
 						if (defined $separator) {
 							my @vs = split($separator, $allvals);
